#Copyright (c) 2018 Vereign AG [https://www.vereign.com]
#
#This is free software: you can redistribute it and/or modify
#it under the terms of the GNU Affero General Public License as
#published by the Free Software Foundation, either version 3 of the
#License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU Affero General Public License for more details.
#
#You should have received a copy of the GNU Affero General Public License
#along with this program. If not, see <http://www.gnu.org/licenses/>.

#/entity/updateClaim
#Author: Rosen Georgiev rosen.georgiev@vereign.com

@rest @entity @all
Feature: VIAM - entity - updateClaim POST
  This endpoint is for updating claim operation of users.

  Background:
    Given we are testing the VIAM Api

  @updateClaim
  Scenario: Update a claim and then Get the entity to verify its updated - Positive
#Create a new member
    Then I register a new random member via VIAM API
    And the field {status} has the value {OK}
#Login the new member
    Given I clear the request body
    Given I login member with mode previousaddeddevice via VIAM API
    And the field {status} has the value {OK}
#Add new claim
    Given I clear the request body
    Given I load the REST request {Claims.json} with profile {create_private}
    Then I add a new claim to the current entity via VIAM API
    And the field {status} has the value {OK}
#Then I update the claim
    Given I set the request fields
      | value | 33 |
    Then I update a claim to the current entity via VIAM API
    And the field {status} has the value {OK}
    And the field {code} has the value {200}

  @updateClaim
  Scenario Outline: Update a claim and then Get the entity to verify its updated - [<profile>]- Positive
#Create a new member
    Then I register a new random member via VIAM API
    And the field {status} has the value {OK}
#Login the new member
    Given I clear the request body
    Given I login member with mode previousaddeddevice via VIAM API
    And the field {status} has the value {OK}
#Add new claim
    Given I clear the request body
    Given I load the REST request {Claims.json} with profile {<profile>}
    Then I add a new claim to the current entity via VIAM API
    And the field {status} has the value {OK}
#Then I update the claim
    Given I set the request fields
      | value | 33 |
    Then I update a claim to the current entity via VIAM API
    And the field {status} has the value {OK}
    And the field {code} has the value {200}
#Get the data of current entity
    Given I clear the request body
    And I set the request fields
      | from | -1 |
      | to   | -1 |
    Then I get the current entity via the VIAM API
    And the field {status} has the value {OK}
    And the field {code} has the value {200}
    And the field {$..claims.age..value.value} has the value {["33"]}
    Examples:
      | profile             |
      | create_private      |
      | create_invitational |

  @updateClaim
  Scenario: Update a claim and then Get the entity to verify its updated - [valueType_updated_composite]- Positive
#Create a new member
    Then I register a new random member via VIAM API
    And the field {status} has the value {OK}
#Login the new member
    Given I clear the request body
    Given I login member with mode previousaddeddevice via VIAM API
    And the field {status} has the value {OK}
#Add new claim
    Given I clear the request body
    Given I load the REST request {Claims.json} with profile {valueType_composite}
    Then I add a new claim to the current entity via VIAM API
    And the field {status} has the value {OK}
#Then I update the claim
    Given I load the REST request {Claims.json} with profile {valueType_updated_composite}
    Then I update a claim to the current entity via VIAM API
    And the field {status} has the value {OK}
    And the field {code} has the value {200}
#Get the data of current entity
    Given I clear the request body
    And I set the request fields
      | from | -1 |
      | to   | -1 |
    Then I get the current entity via the VIAM API
    And the field {status} has the value {OK}
    And the field {code} has the value {200}
    And the field {$..claims.age..value.age} has the value {["33"]}
    And the field {$..claims.age..value.olderThen} has the value {["18"]}

  @updateEntity
  Scenario Outline: Add a claim to a guarded entity and then update it - [<type>] - Positive
#Create a new member
    Then I register a new random member via VIAM API
    And the field {status} has the value {OK}
#Login the new member
    Given I clear the request body
    Given I login member with mode previousaddeddevice via VIAM API
    And the field {status} has the value {OK}
#Create a new entity
    Given I clear the request body
    Then I create a new entity with type {<type>} via VIAM API
    And the field {status} has the value {OK}
#Add new claim to the child entity
    Given I clear the request body
    Given I load the REST request {Claims.json} with profile {create_private}
    Then I add a new claim to the guarded entity via VIAM API
    And the field {status} has the value {OK}
    And the field {code} has the value {200}
#Then I update the claim
    Given I set the request fields
      | value | 33 |
    Then I update a claim to an entity via VIAM API
    And the field {status} has the value {OK}
    And the field {code} has the value {200}
#Get the data of guarded entity
    Given I clear the request body
    And I set the request fields
      | from | -1 |
      | to   | -1 |
    Then I get the guarded entity via the VIAM API
    And the field {status} has the value {OK}
    And the field {code} has the value {200}
    And the field {$..claims.age..value.value} has the value {["33"]}
    Examples:
      | type |
      | 1    |
      | 2    |
      | 3    |
      | 4    |
      | 5    |

  @updateEntity
  Scenario Outline: Add a claim to a guarded entity and then update it- [<type>] - Positive
#Create a new member
    Then I register a new random member via VIAM API
    And the field {status} has the value {OK}
#Login the new member
    Given I clear the request body
    Given I login member with mode previousaddeddevice via VIAM API
    And the field {status} has the value {OK}
#Create a new entity
    Given I clear the request body
    Then I create a new entity with type {<type>} via VIAM API
    And the field {status} has the value {OK}
#Add new claim to the child entity
    Given I clear the request body
    Given I load the REST request {Claims.json} with profile {create_private}
    Then I add a new claim to the guarded entity via VIAM API
    And the field {status} has the value {OK}
    And the field {code} has the value {200}
#Then I update the claim
    Given I set the request fields
      | value | 33 |
    Then I update a claim to an entity via VIAM API
    And the field {status} has the value {OK}
    And the field {code} has the value {200}
    Examples:
      | type |
      | 1    |
      | 2    |
      | 3    |
      | 4    |
      | 5    |

  @updateClaim @negative @bug-rest-20
  Scenario Outline: Try to update a claim with invalid value [<profile>] - Negative
#Create a new member
    Then I register a new random member via VIAM API
    And the field {status} has the value {OK}
#Login the new member
    Given I clear the request body
    Given I login member with mode previousaddeddevice via VIAM API
    And the field {status} has the value {OK}
#Add new claim
    Given I clear the request body
    Given I load the REST request {Claims.json} with profile {create_private}
    Then I add a new claim to the current entity via VIAM API
    And the field {status} has the value {OK}
#Try to update a claim
    Given I clear the request body
    And I load the REST request {Claims.json} with profile {<profile>}
    Then I update a claim to the current entity via VIAM API
    And the field {status} has the value {<status>}
    And the field {code} has the value {<code>}
    And the field {data} has the value {<data>}
    Examples:
      | profile            | status                                   | code | data                                                             |
 #     | nonexistent_claim  | There was an error with the input fields | 400  | There was an error with the input fields: claim is required      |
      | missing_claim      | There was an error with the input fields | 400  | There was an error with the input fields: claim is required      |
      | missing_value      | There was an error with the input fields | 400  | There was an error with the input fields: value is required      |
      | missing_access     | There was an error with the input fields | 400  | There was an error with the input fields: access is required     |
      | missing_tag        | There was an error with the input fields | 400  | There was an error with the input fields: tag is required        |
      | missing_valueType  | There was an error with the input fields | 400  | There was an error with the input fields: valueType is required  |
    #  | invalid_access     | There was an error during addition of claim | 400  | There was an error with the input fields: entityuuid is required |

  @updateClaim @negative @bug-rest-20
  Scenario Outline: Try to update a claim with invalid value [<profile>] - Negative
#Create a new member
    Then I register a new random member via VIAM API
    And the field {status} has the value {OK}
#Login the new member
    Given I clear the request body
    Given I login member with mode previousaddeddevice via VIAM API
    And the field {status} has the value {OK}
#Add new claim
    Given I clear the request body
    Given I load the REST request {Claims.json} with profile {create_private}
    Then I add a new claim to the current entity via VIAM API
    And the field {status} has the value {OK}
#Try to update a claim
    Given I clear the request body
    Given I load the REST request {Claims.json} with profile {<profile>}
    Then I update a claim to an entity via VIAM API
    And the field {status} has the value {<status>}
    And the field {code} has the value {<code>}
    And the field {data} has the value {<data>}
    Examples:
      | profile            | status                                   | code | data                                                             |
      | missing_entityuuid | There was an error with the input fields | 400  | There was an error with the input fields: entityuuid is required |

  @updateClaim @negative
  Scenario Outline: Try to update a claim with missing header [<header>] - negative
#Create a new member
    Then I register a new random member via VIAM API
    And the field {status} has the value {OK}
#Login the new member
    Given I clear the request body
    Given I login member with mode previousaddeddevice via VIAM API
    And the field {status} has the value {OK}
#Add new claim
    Given I clear the request body
    Given I load the REST request {Claims.json} with profile {create_private}
    Then I add a new claim to the current entity via VIAM API
    And the field {status} has the value {OK}
#Try to Update the claim
    And I delete the headers
      | <header> |
    Then I update a claim to an entity via VIAM API
    And the field {status} has the value {No authentication values}
    And the field {code} has the value {400}
    Examples:
      | header    |
      | token     |
      | uuid      |
      | publicKey |